#include <iostream>
#include <string.h>
using namespace std;

// Maximal length of email string
const int MAX_EMAIL_LENGTH = 30;

class CPerson {
protected:
    char m_email[MAX_EMAIL_LENGTH+1];
public:
    CPerson(const char* email) {
        strncpy(m_email, email, MAX_EMAIL_LENGTH);
        m_email[MAX_EMAIL_LENGTH] = 0;
    }
    const char* getEmail() { return m_email; }
};

class CStudent : virtual public CPerson {
public:
    // modifikace c. 1: student ma mit mail s prefixem "x"
    CStudent(const char* email) : CPerson(email) {
        char tmp[MAX_EMAIL_LENGTH];
        memset(tmp, 0, MAX_EMAIL_LENGTH);
        strcat(tmp, "x");
        strcat(tmp, m_email);
        // protoze je o 1 delsi, ochrana proti preteceni atributu
        strncpy(m_email, tmp, MAX_EMAIL_LENGTH-1);
    }
};

class CTeacher : virtual public CPerson {
public:
    CTeacher(const char* email) : CPerson(email) {}
};

class CTeachStudent {
public:
    // modifikace c. 2: uz nemame predky, mame atributy - tedy upravime
    // konstruktor; navic nededime z CTeacher ani CStudent, tedy nelze
    // pouzit primy pristup k atributu m_email studenta ani ucitele
    CTeachStudent(const char* email) : m_student(email), m_teacher(email) {}
    void printEmail() {
        cout << m_teacher.getEmail() << endl;
        cout << m_student.getEmail() << endl;
    }
private:
    CTeacher m_teacher;
    CStudent m_student;
};


int main() {
    // modifikace c. 3: splnili jsme zadani, ale za cenu ztraty pretypovani
    // na rodice ; kterak kompenzovat bude pozdeji v semestru
    // toto reseni se obecne hodi pokud pracujeme s cizim kodem ktery
    // nemuzeme menit
    CTeachStudent teachStud("novak@fi.muni.cz");
    teachStud.printEmail();

    return 0;
}

