#include <iostream>
#include <string.h>
using namespace std;

// Maximal length of email string
const int MAX_EMAIL_LENGTH = 30;

class CPerson {
protected:
    char m_email[MAX_EMAIL_LENGTH+1];
public:
    CPerson(const char* email) {
        strncpy(m_email, email, MAX_EMAIL_LENGTH);
        m_email[MAX_EMAIL_LENGTH] = 0;
    }
    const char* getEmail() { return m_email; }
};

// modifikace c. 1: pokud ma fungovat pozdni vazba (virtualni dedicnost)
// pak je potreba tradicne upravit nejvyssi vztah - tedy pridat virtualni
// dedicnost jiz zde
class CStudent : virtual public CPerson {
public:
    CStudent(const char* email) : CPerson(email) {}
};

// modifikace c. 2: to stejne jako 1
class CTeacher : virtual public CPerson {
public:
    CTeacher(const char* email) : CPerson(email) {}
};

class CTeachStudent : public CTeacher, public CStudent {
public:
    // modifikace c. 3: CPerson uz neni fyzicky soucasti ani CTeacher,
    // ani CStudent - odpovidajici podcast je treba vytvorit s poslednim
    // clankem hierarchie
    CTeachStudent(const char* email) : CPerson(email), CTeacher(email), CStudent(email) {}
    void printEmail() {
        cout << m_email;
    }
};


int main() {
    // modifikace c. 4: toto reseni sice resi nejednoznacnost atributu,
    // nesplnuje ale zadani (jiny email pro studenta a ucitele)...
    // toto reseni se tedy hodi pouze pokud ocekavame ze s problematickym
    // predkem budou vsichni zachazet stejne a bez rozdilu
    CTeachStudent teachStud("novak@fi.muni.cz");
    teachStud.printEmail();

    return 0;
}

