#include <iostream>
#include <cstring>
#include <cstdlib>

class experiment {
public:
    experiment():m_data(NULL){ ; }

    experiment(const char * data):m_data(NULL){
        m_data = strdup(data);
    }

    // kopirovaci konstruktor - argument musi byt typu
    // (konstantni) reference, jinak by se volal pro predani sveho
    // argumentu, pro coz by bylo potreba vytvorit kopii, pro kterou by
    // se volal kopirovaci konstruktor, ktery by se volal ... atd.
    experiment(const experiment & original):m_data(NULL){
        m_data = (char *)calloc(strlen(original.m_data)+1, 1);
        strcpy(m_data, original.m_data);
    }

    ~experiment(){
        if (m_data){ free(m_data); m_data = NULL; }
    }

    // referenci take - podobne jako ukazatelem - predavame
    // argumenty jejichz zmenu chceme vypropagovat vem z funkce
    void print_to_stream(std::ostream & output){
        if (m_data){ output << m_data; }
    }

    // pokud nenapiseme vlastni operator prirazeni, kompilator to udela
    // podobne jako v pripade plitkeho kopirovaciho konstruktoru
    experiment & operator=(const experiment & original){
        // adresa reference je shodna s adresou puvodniho objektu
        // zkuste si co by se stalo pokud bychom netestovali sebeprirazeni
        if (&original != this){
            if (m_data){ free(m_data); m_data = NULL; }
            m_data = (char *)calloc(strlen(original.m_data)+1, 1);
            strcpy(m_data, original.m_data);
        }

        // z C je vam tento koncept znamy, ted jej konecne dokazete
        // pojmenovat - operator dereference (* pred ukazatelem ktera
        // zpristupnuje data z ukazatele) ve skutecnosti vraci referenci
        return *this;
    }

private:
    char * m_data;

};

int main(){

    experiment tiskarna;
    {
        experiment docasna_tiskarna("Toto je text pro standardni vystup");
        tiskarna = docasna_tiskarna;
    }
    tiskarna.print_to_stream(std::cout);

    return 0;

}
